#include "client_server_interact.h"
#include <engine_engine_number_9/form_data_structure/urlencoded_query.h>
#include <engine_engine_number_9/baza_throw.h>
#include <string.h>
#include "../str_fields.h"

namespace iu9cawebchat {
    std::string when_page_register(WorkerGuestData& wgd, const json::JSON& config_presentation,
                const een9::ClientRequest& req, const json::JSON& userinfo) {

        const json::JSON& reg_pres = config_presentation["register"];
        json::JSON msg_list = json::JSON(json::array);
        if (req.method == "POST") {
            if (userinfo.isNull() || userinfo["uid"].asInteger().get_int() != 0)
                een9_THROW("Unauthorized access");
            // Kod dlya dobaldal lkslkfjgk
            std::vector<std::pair<std::string, std::string>> query = een9::split_html_query(req.body);
            std::string nickname;
            std::string name;
            std::string password;
            std::vector<HtmlMsgBox> problems;  // We explain problem to root
            for (const std::pair<std::string, std::string>& cmp: query) {
                if (cmp.first == "nickname")
                    nickname = cmp.second;
                if (cmp.first == "name")
                    name = cmp.second;
                if (cmp.first == "password")
                    password = cmp.second;
            }
            if (!check_nickname(nickname)) {
                problems.push_back({"", reg_pres["incorrect-nickname"].asString()});
            }
            if (!check_name(name)) {
                problems.push_back({"", reg_pres["incorrect-name"].asString()});
            }
            if (!check_strong_password(password)) {
                problems.push_back({"", reg_pres["incorrect-password"].asString()});
            }
            if (is_nickname_taken(*wgd.db, nickname)) {
                problems.push_back({"", reg_pres["nickname-taken"].asString()});
            }
            if (problems.empty()) {
                try {
                    add_user(*wgd.db, nickname, name, password, "");
                } catch (std::exception& err) {
                    problems.push_back({"", reg_pres["add_user_error"].asString()});
                }
            }
            msg_list = jsonify_html_message_list(problems);
            return http_R200("register", wgd, {&config_presentation, &userinfo, &msg_list});
        }
        if (userinfo.isNull() || userinfo["uid"].asInteger().get_int() != 0)
            return page_E404(wgd);
        return http_R200("register", wgd, {&config_presentation, &userinfo, &msg_list});
    }
}
